Package icyllis.modernui.transition

# Class TransitionSet

java.lang.Object
icyllis.modernui.transition.Transition
icyllis.modernui.transition.TransitionSet

All Implemented Interfaces:
  `Cloneable`

Direct Known Subclasses:
  `AutoTransition`

public class TransitionSet extends Transition
A TransitionSet is a parent of child transitions (including other TransitionSets). Using TransitionSets enables more complex choreography of transitions, where some sets play `ORDERING_TOGETHER` and others play `ORDERING_SEQUENTIAL`. For example, `AutoTransition` uses a TransitionSet to sequentially play a Fade(Fade.OUT), followed by a
invalid reference

    ChangeBounds

, followed by a Fade(Fade.OUT) transition.

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class icyllis.modernui.transition.Transition

  `Transition.EpicenterCallback, Transition.MatchOrder`

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final int`
  `ORDERING_SEQUENTIAL`
  A flag used to indicate that the child transitions of this set should play in sequence; when one child transition ends, the next child transition begins.
  `static final int`
  `ORDERING_TOGETHER`
  A flag used to indicate that the child transitions of this set should all start at the same time.

  ### Fields inherited from class icyllis.modernui.transition.Transition

  `MATCH_ID, MATCH_INSTANCE, MATCH_ITEM_ID, MATCH_NAME`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `TransitionSet()`
  Constructs an empty transition set.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `TransitionSet`
  `addListener(TransitionListener listener)`
  Adds a listener to the set of listeners that are sent events through the life of an animation, such as start, repeat, and end.
  `TransitionSet`
  `addTarget(int targetId)`
  Adds the id of a target view that this Transition is interested in animating.
  `TransitionSet`
  `addTarget(View target)`
  Sets the target view instances that this Transition is interested in animating.
  `TransitionSet`
  `addTarget(Class<?> targetType)`
  Adds the Class of a target view that this Transition is interested in animating.
  `TransitionSet`
  `addTarget(String targetName)`
  Adds the transitionName of a target view that this Transition is interested in animating.
  `TransitionSet`
  `addTransition(Transition transition)`
  Adds child transition to this set.
  `void`
  `cancel()`
  This method cancels a transition that is currently running.
  `void`
  `captureEndValues(TransitionValues transitionValues)`
  Captures the values in the end scene for the properties that this transition monitors.
  `void`
  `captureStartValues(TransitionValues transitionValues)`
  Captures the values in the start scene for the properties that this transition monitors.
  `Transition`
  `clone()`
  `protected void`
  `createAnimators(ViewGroup sceneRoot, icyllis.modernui.transition.Transition.TransitionValuesMaps startValues, icyllis.modernui.transition.Transition.TransitionValuesMaps endValues, ArrayList<TransitionValues> startValuesList, ArrayList<TransitionValues> endValuesList)`
  This method, essentially a wrapper around all calls to createAnimator for all possible target views, is called with the entire set of start/end values.
  `Transition`
  `excludeTarget(int targetId, boolean exclude)`
  Whether to add the given id to the list of target ids to exclude from this transition.
  `Transition`
  `excludeTarget(View target, boolean exclude)`
  Whether to add the given target to the list of targets to exclude from this transition.
  `Transition`
  `excludeTarget(Class<?> type, boolean exclude)`
  Whether to add the given type to the list of types to exclude from this transition.
  `Transition`
  `excludeTarget(String targetName, boolean exclude)`
  Whether to add the given transitionName to the list of target transitionNames to exclude from this transition.
  `int`
  `getOrdering()`
  Returns the ordering of this TransitionSet.
  `Transition`
  `getTransitionAt(int index)`
  Returns the child Transition at the specified position in the TransitionSet.
  `int`
  `getTransitionCount()`
  Returns the number of child transitions in the TransitionSet.
  `void`
  `pause(View sceneRoot)`
  Pauses this transition, sending out calls to `TransitionListener.onTransitionPause(Transition)` to all listeners and pausing all running animators started by this transition.
  `TransitionSet`
  `removeListener(TransitionListener listener)`
  Removes a listener from the set listening to this animation.
  `TransitionSet`
  `removeTarget(int targetId)`
  Removes the given targetId from the list of ids that this Transition is interested in animating.
  `TransitionSet`
  `removeTarget(View target)`
  Removes the given target from the list of targets that this Transition is interested in animating.
  `TransitionSet`
  `removeTarget(Class<?> target)`
  Removes the given target from the list of targets that this Transition is interested in animating.
  `TransitionSet`
  `removeTarget(String target)`
  Removes the given targetName from the list of transitionNames that this Transition is interested in animating.
  `TransitionSet`
  `removeTransition(Transition transition)`
  Removes the specified child transition from this set.
  `void`
  `resume(View sceneRoot)`
  Resumes this transition, sending out calls to `TransitionListener.onTransitionPause(Transition)` to all listeners and pausing all running animators started by this transition.
  `protected void`
  `runAnimators()`
  This is called internally once all animations have been set up by the transition hierarchy.
  `TransitionSet`
  `setDuration(long duration)`
  Setting a non-negative duration on a TransitionSet causes all of the child transitions (current and future) to inherit this duration.
  `void`
  `setEpicenterCallback(Transition.EpicenterCallback epicenterCallback)`
  Sets the callback to use to find the epicenter of a Transition.
  `TransitionSet`
  `setInterpolator(TimeInterpolator interpolator)`
  Sets the interpolator of this transition.
  `TransitionSet`
  `setOrdering(int ordering)`
  Sets the play order of this set's child transitions.
  `void`
  `setPropagation(TransitionPropagation propagation)`
  Sets the method for determining Animator start delays.
  `TransitionSet`
  `setStartDelay(long startDelay)`
  Sets the startDelay of this transition.

  ### Methods inherited from class icyllis.modernui.transition.Transition

  `animate, createAnimator, end, excludeChildren, excludeChildren, excludeChildren, getDuration, getEpicenter, getEpicenterCallback, getInterpolator, getName, getPropagation, getStartDelay, getTargetIds, getTargetNames, getTargets, getTargetTypes, getTransitionProperties, getTransitionValues, isTransitionRequired, setMatchOrder, start, toString`

  ### Methods inherited from class java.lang.Object

  `equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Field Details

  - ### ORDERING_TOGETHER

    public static final int ORDERING_TOGETHER
    A flag used to indicate that the child transitions of this set should all start at the same time.
    See Also:
      - Constant Field Values

  - ### ORDERING_SEQUENTIAL

    public static final int ORDERING_SEQUENTIAL
    A flag used to indicate that the child transitions of this set should play in sequence; when one child transition ends, the next child transition begins. Note that a transition does not end until all instances of it (which are playing on all applicable targets of the transition) end.
    See Also:
      - Constant Field Values

- ## Constructor Details

  - ### TransitionSet

    public TransitionSet()
    Constructs an empty transition set. Add child transitions to the set by calling `addTransition(Transition)` )}. By default, child transitions will play `together`.

- ## Method Details

  - ### setOrdering

    @Nonnull public TransitionSet setOrdering(int ordering)
    Sets the play order of this set's child transitions.
    Parameters:
      `ordering` - `ORDERING_TOGETHER` to play this set's child transitions together, `ORDERING_SEQUENTIAL` to play the child transitions in sequence.
    Returns:
      This transitionSet object.

  - ### getOrdering

    public int getOrdering()
    Returns the ordering of this TransitionSet. By default, the value is `ORDERING_TOGETHER`.
    Returns:
      `ORDERING_TOGETHER` if child transitions will play at the same time, `ORDERING_SEQUENTIAL` if they will play in sequence.
    See Also:
      - `setOrdering(int)`

  - ### addTransition

    @Nonnull public TransitionSet addTransition(@Nonnull Transition transition)
    Adds child transition to this set. The order in which this child transition is added relative to other child transitions that are added, in addition to the `ordering` property, determines the order in which the transitions are started.

    If this transitionSet has a `duration`, `interpolator`, `propagation delay`,

    invalid reference

        path motion

    , or `epicenter callback` set on it, the child transition will inherit the values that are set. Transitions are assumed to have a maximum of one transitionSet parent.
    Parameters:
      `transition` - A non-null child transition to be added to this set.
    Returns:
      This transitionSet object.

  - ### getTransitionCount

    public int getTransitionCount()
    Returns the number of child transitions in the TransitionSet.
    Returns:
      The number of child transitions in the TransitionSet.
    See Also:
      - `addTransition(Transition)`
      - `getTransitionAt(int)`

  - ### getTransitionAt

    @Nullable public Transition getTransitionAt(int index)
    Returns the child Transition at the specified position in the TransitionSet.
    Parameters:
      `index` - The position of the Transition to retrieve.
    See Also:
      - `addTransition(Transition)`
      - `getTransitionCount()`

  - ### setDuration

    @Nonnull public TransitionSet setDuration(long duration)
    Setting a non-negative duration on a TransitionSet causes all of the child transitions (current and future) to inherit this duration.
    Overrides:
      `setDuration` in class `Transition`
    Parameters:
      `duration` - The length of the animation, in milliseconds.
    Returns:
      This transitionSet object.

  - ### setStartDelay

    @Nonnull public TransitionSet setStartDelay(long startDelay)
    Description copied from class: `Transition`
    Sets the startDelay of this transition. By default, there is no delay (indicated by a negative number), which means that the Animator created by the transition will have its own specified startDelay. If the delay of a Transition is set, that delay will override the Animator delay.
    Overrides:
      `setStartDelay` in class `Transition`
    Parameters:
      `startDelay` - The length of the delay, in milliseconds.
    Returns:
      This transition object.

  - ### setInterpolator

    @Nonnull public TransitionSet setInterpolator(@Nullable TimeInterpolator interpolator)
    Description copied from class: `Transition`
    Sets the interpolator of this transition. By default, the interpolator is null, which means that the Animator created by the transition will have its own specified interpolator. If the interpolator of a Transition is set, that interpolator will override the Animator interpolator.
    Overrides:
      `setInterpolator` in class `Transition`
    Parameters:
      `interpolator` - The time interpolator used by the transition
    Returns:
      This transition object.

  - ### addTarget

    @Nonnull public TransitionSet addTarget(@Nonnull View target)
    Description copied from class: `Transition`
    Sets the target view instances that this Transition is interested in animating. By default, there are no targets, and a Transition will listen for changes on every view in the hierarchy below the sceneRoot of the Scene being transitioned into. Setting targets constrains the Transition to only listen for, and act on, these views. All other views will be ignored.

    The target list is like the `targetId` list except this list specifies the actual View instances, not the ids of the views. This is an important distinction when scene changes involve view hierarchies which have been inflated separately; different views may share the same id but not actually be the same instance. If the transition should treat those views as the same, then `Transition.addTarget(int)` should be used instead of this method. If, on the other hand, scene changes involve changes all within the same view hierarchy, among views which do not necessarily have ids set on them, then the target list of views may be more convenient.

    Overrides:
      `addTarget` in class `Transition`
    Parameters:
      `target` - A View on which the Transition will act, must be non-null.
    Returns:
      The Transition to which the target is added. Returning the same object makes it easier to chain calls during construction, such as `transitionSet.addTransitions(new Fade()).addTarget(someView);`
    See Also:
      - `Transition.addTarget(int)`

  - ### addTarget

    @Nonnull public TransitionSet addTarget(int targetId)
    Description copied from class: `Transition`
    Adds the id of a target view that this Transition is interested in animating. By default, there are no targetIds, and a Transition will listen for changes on every view in the hierarchy below the sceneRoot of the Scene being transitioned into. Setting targetIds constrains the Transition to only listen for, and act on, views with these IDs. Views with different IDs, or no IDs whatsoever, will be ignored.

    Note that using ids to specify targets implies that ids should be unique within the view hierarchy underneath the scene root.

    Overrides:
      `addTarget` in class `Transition`
    Parameters:
      `targetId` - The id of a target view, must be a positive number.
    Returns:
      The Transition to which the targetId is added. Returning the same object makes it easier to chain calls during construction, such as `transitionSet.addTransitions(new Fade()).addTarget(someId);`
    See Also:
      - `View.getId()`

  - ### addTarget

    @Nonnull public TransitionSet addTarget(@Nonnull String targetName)
    Description copied from class: `Transition`
    Adds the transitionName of a target view that this Transition is interested in animating. By default, there are no targetNames, and a Transition will listen for changes on every view in the hierarchy below the sceneRoot of the Scene being transitioned into. Setting targetNames constrains the Transition to only listen for, and act on, views with these transitionNames. Views with different transitionNames, or no transitionName whatsoever, will be ignored.

    Note that transitionNames should be unique within the view hierarchy.

    Overrides:
      `addTarget` in class `Transition`
    Parameters:
      `targetName` - The transitionName of a target view, must be non-null.
    Returns:
      The Transition to which the target transitionName is added. Returning the same object makes it easier to chain calls during construction, such as `transitionSet.addTransitions(new Fade()).addTarget(someName);`
    See Also:
      - `View.getTransitionName()`

  - ### addTarget

    @Nonnull public TransitionSet addTarget(@Nonnull Class<?> targetType)
    Description copied from class: `Transition`
    Adds the Class of a target view that this Transition is interested in animating. By default, there are no targetTypes, and a Transition will listen for changes on every view in the hierarchy below the sceneRoot of the Scene being transitioned into. Setting targetTypes constrains the Transition to only listen for, and act on, views with these classes. Views with different classes will be ignored.

    Note that any View that can be cast to targetType will be included, so if targetType is `View.class`, all Views will be included.

    Overrides:
      `addTarget` in class `Transition`
    Parameters:
      `targetType` - The type to include when running this transition.
    Returns:
      The Transition to which the target class was added. Returning the same object makes it easier to chain calls during construction, such as `transitionSet.addTransitions(new Fade()).addTarget(ImageView.class);`
    See Also:
      - `Transition.addTarget(int)`
      - `Transition.addTarget(View)`
      - `Transition.excludeTarget(Class, boolean)`
      - `Transition.excludeChildren(Class, boolean)`

  - ### addListener

    @Nonnull public TransitionSet addListener(@Nonnull TransitionListener listener)
    Description copied from class: `Transition`
    Adds a listener to the set of listeners that are sent events through the life of an animation, such as start, repeat, and end.
    Overrides:
      `addListener` in class `Transition`
    Parameters:
      `listener` - the listener to be added to the current set of listeners for this animation.
    Returns:
      This transition object.

  - ### removeTarget

    @Nonnull public TransitionSet removeTarget(int targetId)
    Description copied from class: `Transition`
    Removes the given targetId from the list of ids that this Transition is interested in animating.
    Overrides:
      `removeTarget` in class `Transition`
    Parameters:
      `targetId` - The id of a target view, must be a positive number.
    Returns:
      The Transition from which the targetId is removed. Returning the same object makes it easier to chain calls during construction, such as `transitionSet.addTransitions(new Fade()).removeTargetId(someId);`

  - ### removeTarget

    @Nonnull public TransitionSet removeTarget(@Nonnull View target)
    Description copied from class: `Transition`
    Removes the given target from the list of targets that this Transition is interested in animating.
    Overrides:
      `removeTarget` in class `Transition`
    Parameters:
      `target` - The target view, must be non-null.
    Returns:
      Transition The Transition from which the target is removed. Returning the same object makes it easier to chain calls during construction, such as `transitionSet.addTransitions(new Fade()).removeTarget(someView);`

  - ### removeTarget

    @Nonnull public TransitionSet removeTarget(@Nonnull Class<?> target)
    Description copied from class: `Transition`
    Removes the given target from the list of targets that this Transition is interested in animating.
    Overrides:
      `removeTarget` in class `Transition`
    Parameters:
      `target` - The type of the target view, must be non-null.
    Returns:
      Transition The Transition from which the target is removed. Returning the same object makes it easier to chain calls during construction, such as `transitionSet.addTransitions(new Fade()).removeTarget(someType);`

  - ### removeTarget

    @Nonnull public TransitionSet removeTarget(@Nonnull String target)
    Description copied from class: `Transition`
    Removes the given targetName from the list of transitionNames that this Transition is interested in animating.
    Overrides:
      `removeTarget` in class `Transition`
    Parameters:
      `target` - The transitionName of a target view, must not be null.
    Returns:
      The Transition from which the targetName is removed. Returning the same object makes it easier to chain calls during construction, such as `transitionSet.addTransitions(new Fade()).removeTargetName(someName);`

  - ### excludeTarget

    @Nonnull public Transition excludeTarget(@Nonnull View target, boolean exclude)
    Description copied from class: `Transition`
    Whether to add the given target to the list of targets to exclude from this transition. The `exclude` parameter specifies whether the target should be added to or removed from the excluded list.

    Excluding targets is a general mechanism for allowing transitions to run on a view hierarchy while skipping target views that should not be part of the transition. For example, you may want to avoid animating children of a specific ListView or Spinner. Views can be excluded either by their id, or by their instance reference, or by the Class of that view (eg, `Spinner`).

    Overrides:
      `excludeTarget` in class `Transition`
    Parameters:
      `target` - The target to ignore when running this transition.
      `exclude` - Whether to add the target to or remove the target from the current list of excluded targets.
    Returns:
      This transition object.
    See Also:
      - `Transition.excludeChildren(View, boolean)`
      - `Transition.excludeTarget(int, boolean)`
      - `Transition.excludeTarget(Class, boolean)`

  - ### excludeTarget

    @Nonnull public Transition excludeTarget(@Nonnull String targetName, boolean exclude)
    Description copied from class: `Transition`
    Whether to add the given transitionName to the list of target transitionNames to exclude from this transition. The `exclude` parameter specifies whether the target should be added to or removed from the excluded list.

    Excluding targets is a general mechanism for allowing transitions to run on a view hierarchy while skipping target views that should not be part of the transition. For example, you may want to avoid animating children of a specific ListView or Spinner. Views can be excluded by their id, their instance reference, their transitionName, or by the Class of that view (eg, `Spinner`).

    Overrides:
      `excludeTarget` in class `Transition`
    Parameters:
      `targetName` - The name of a target to ignore when running this transition.
      `exclude` - Whether to add the target to or remove the target from the current list of excluded targets.
    Returns:
      This transition object.
    See Also:
      - `Transition.excludeTarget(View, boolean)`
      - `Transition.excludeTarget(int, boolean)`
      - `Transition.excludeTarget(Class, boolean)`

  - ### excludeTarget

    @Nonnull public Transition excludeTarget(int targetId, boolean exclude)
    Description copied from class: `Transition`
    Whether to add the given id to the list of target ids to exclude from this transition. The `exclude` parameter specifies whether the target should be added to or removed from the excluded list.

    Excluding targets is a general mechanism for allowing transitions to run on a view hierarchy while skipping target views that should not be part of the transition. For example, you may want to avoid animating children of a specific ListView or Spinner. Views can be excluded either by their id, or by their instance reference, or by the Class of that view (eg, `Spinner`).

    Overrides:
      `excludeTarget` in class `Transition`
    Parameters:
      `targetId` - The id of a target to ignore when running this transition.
      `exclude` - Whether to add the target to or remove the target from the current list of excluded targets.
    Returns:
      This transition object.
    See Also:
      - `Transition.excludeChildren(int, boolean)`
      - `Transition.excludeTarget(View, boolean)`
      - `Transition.excludeTarget(Class, boolean)`

  - ### excludeTarget

    @Nonnull public Transition excludeTarget(@Nonnull Class<?> type, boolean exclude)
    Description copied from class: `Transition`
    Whether to add the given type to the list of types to exclude from this transition. The `exclude` parameter specifies whether the target type should be added to or removed from the excluded list.

    Excluding targets is a general mechanism for allowing transitions to run on a view hierarchy while skipping target views that should not be part of the transition. For example, you may want to avoid animating children of a specific ListView or Spinner. Views can be excluded either by their id, or by their instance reference, or by the Class of that view (eg, `Spinner`).

    Overrides:
      `excludeTarget` in class `Transition`
    Parameters:
      `type` - The type to ignore when running this transition.
      `exclude` - Whether to add the target type to or remove it from the current list of excluded target types.
    Returns:
      This transition object.
    See Also:
      - `Transition.excludeChildren(Class, boolean)`
      - `Transition.excludeTarget(int, boolean)`
      - `Transition.excludeTarget(View, boolean)`

  - ### removeListener

    @Nonnull public TransitionSet removeListener(@Nonnull TransitionListener listener)
    Description copied from class: `Transition`
    Removes a listener from the set listening to this animation.
    Overrides:
      `removeListener` in class `Transition`
    Parameters:
      `listener` - the listener to be removed from the current set of listeners for this transition.
    Returns:
      This transition object.

  - ### removeTransition

    @Nonnull public TransitionSet removeTransition(@Nonnull Transition transition)
    Removes the specified child transition from this set.
    Parameters:
      `transition` - The transition to be removed.
    Returns:
      This transitionSet object.

  - ### createAnimators

    protected void createAnimators(@Nonnull ViewGroup sceneRoot, @Nonnull icyllis.modernui.transition.Transition.TransitionValuesMaps startValues, @Nonnull icyllis.modernui.transition.Transition.TransitionValuesMaps endValues, @Nonnull ArrayList<TransitionValues> startValuesList, @Nonnull ArrayList<TransitionValues> endValuesList)
    Description copied from class: `Transition`
    This method, essentially a wrapper around all calls to createAnimator for all possible target views, is called with the entire set of start/end values. The implementation in Transition iterates through these lists and calls `Transition.createAnimator(ViewGroup, TransitionValues, TransitionValues)` with each set of start/end values on this transition. The TransitionSet subclass overrides this method and delegates it to each of its children in succession.
    Overrides:
      `createAnimators` in class `Transition`

  - ### runAnimators

    protected void runAnimators()
    Description copied from class: `Transition`
    This is called internally once all animations have been set up by the transition hierarchy.
    Overrides:
      `runAnimators` in class `Transition`

  - ### captureStartValues

    public void captureStartValues(@Nonnull TransitionValues transitionValues)
    Description copied from class: `Transition`
    Captures the values in the start scene for the properties that this transition monitors. These values are then passed as the startValues structure in a later call to `Transition.createAnimator(ViewGroup, TransitionValues, TransitionValues)`. The main concern for an implementation is what the properties are that the transition cares about and what the values are for all of those properties. The start and end values will be compared later during the `Transition.createAnimator(ViewGroup, TransitionValues, TransitionValues)` method to determine what, if any, animations, should be run.

    Subclasses must implement this method. The method should only be called by the transition system; it is not intended to be called from external classes.

    Specified by:
      `captureStartValues` in class `Transition`
    Parameters:
      `transitionValues` - The holder for any values that the Transition wishes to store. Values are stored in the `values` field of this TransitionValues object and are keyed from a String value. For example, to store a view's rotation value, a transition might call `transitionValues.values.put("appname:transitionname:rotation", view.getRotation())`. The target view will already be stored in the transitionValues structure when this method is called.
    See Also:
      - `Transition.captureEndValues(TransitionValues)`
      - `Transition.createAnimator(ViewGroup, TransitionValues, TransitionValues)`

  - ### captureEndValues

    public void captureEndValues(@Nonnull TransitionValues transitionValues)
    Description copied from class: `Transition`
    Captures the values in the end scene for the properties that this transition monitors. These values are then passed as the endValues structure in a later call to `Transition.createAnimator(ViewGroup, TransitionValues, TransitionValues)`. The main concern for an implementation is what the properties are that the transition cares about and what the values are for all of those properties. The start and end values will be compared later during the `Transition.createAnimator(ViewGroup, TransitionValues, TransitionValues)` method to determine what, if any, animations, should be run.

    Subclasses must implement this method. The method should only be called by the transition system; it is not intended to be called from external classes.

    Specified by:
      `captureEndValues` in class `Transition`
    Parameters:
      `transitionValues` - The holder for any values that the Transition wishes to store. Values are stored in the `values` field of this TransitionValues object and are keyed from a String value. For example, to store a view's rotation value, a transition might call `transitionValues.values.put("appname:transitionname:rotation", view.getRotation())`. The target view will already be stored in the transitionValues structure when this method is called.
    See Also:
      - `Transition.captureStartValues(TransitionValues)`
      - `Transition.createAnimator(ViewGroup, TransitionValues, TransitionValues)`

  - ### pause

    public void pause(View sceneRoot)
    Description copied from class: `Transition`
    Pauses this transition, sending out calls to `TransitionListener.onTransitionPause(Transition)` to all listeners and pausing all running animators started by this transition.
    Overrides:
      `pause` in class `Transition`

  - ### resume

    public void resume(@Nonnull View sceneRoot)
    Description copied from class: `Transition`
    Resumes this transition, sending out calls to `TransitionListener.onTransitionPause(Transition)` to all listeners and pausing all running animators started by this transition.
    Overrides:
      `resume` in class `Transition`

  - ### cancel

    public void cancel()
    Description copied from class: `Transition`
    This method cancels a transition that is currently running.
    Overrides:
      `cancel` in class `Transition`

  - ### setPropagation

    public void setPropagation(@Nullable TransitionPropagation propagation)
    Description copied from class: `Transition`
    Sets the method for determining Animator start delays.

    When a Transition affects several Views like `Explode` or `Slide`, there may be a desire to have a "wave-front" effect such that the Animator start delay depends on position of the View. The TransitionPropagation specifies how the start delays are calculated.

    Overrides:
      `setPropagation` in class `Transition`
    Parameters:
      `propagation` - The class used to determine the start delay of Animators created by this Transition. A null value indicates that no delay should be used.

  - ### setEpicenterCallback

    public void setEpicenterCallback(@Nullable Transition.EpicenterCallback epicenterCallback)
    Description copied from class: `Transition`
    Sets the callback to use to find the epicenter of a Transition. A null value indicates that there is no epicenter in the Transition and onGetEpicenter() will return null. Transitions like `Explode` use a point or Rect to orient the direction of travel. This is called the epicenter of the Transition and is typically centered on a touched View. The `Transition.EpicenterCallback` allows a Transition to dynamically retrieve the epicenter during a Transition.
    Overrides:
      `setEpicenterCallback` in class `Transition`
    Parameters:
      `epicenterCallback` - The callback to use to find the epicenter of the Transition.

  - ### clone

    public Transition clone()
    Overrides:
      `clone` in class `Transition`